#!/bin/bash
#contributed by Andrei Chevel 
#contributed by Fredrik Steen
#contributed by Gonri Le Bouder <goneri@free.fr>


TOP=/usr/bin/top
AWK=/bin/awk
GMETRIC=/usr/bin/gmetric
RM=/bin/rm

NETLOAD=0

$TOP -ibn 1 | $AWK /COMMAND/,/++++++++++/ | head -2 | tail -1 > /tmp/t$$

$RM -f /tmp/t$$

NBRE=1
# For each network interface


for INTERFACE in `cat /proc/net/dev | grep eth | cut -d : -f1`
do
 NBRE=`expr $NBRE - 1`
 INTERFACE=eth$NBRE

 IN=`grep $INTERFACE /proc/net/dev | awk -F\: '{print($2)}' | awk '{print($1)}'`
 OUT=`grep $INTERFACE /proc/net/dev | awk -F\: '{print($2)}' | awk '{print($9)}'`

 sleep 1

 let OUT=(`grep $INTERFACE /proc/net/dev | awk -F\: '{print($2)}' | awk '{print($9)}'`-$OUT)
 let IN=(`grep $INTERFACE /proc/net/dev | awk -F\: '{print($2)}' | awk '{print($1)}'`-$IN)

let NETLOAD_LOAD=($IN+$OUT)
 
 $GMETRIC --name "$INTERFACE in"  --value $IN --type uint32 --units 'b/s'
 $GMETRIC --name "$INTERFACE out"  --value $OUT --type uint32 --units 'b/s'
 
 $GMETRIC --name "network_load"  --value $NETLOAD_LOAD --type uint32 --units 'b/s'
done

 $GMETRIC -t uint16 -n TCP_ESTABLISHED -v `/bin/netstat -t -n|egrep "ESTABLISHED"|wc -l`

